Bug 648673 (CVE-2010-4083) - CVE-2010-4083 kernel: ipc/sem.c: reading uninitialized stack memory
Summary: CVE-2010-4083 kernel: ipc/sem.c: reading uninitialized stack memory
Keywords:
Status: NEW
Alias: CVE-2010-4083
Product: Security Response
Classification: Other
Component: vulnerability
Version: unspecified
Hardware: Unspecified
OS: Unspecified
low
low
Target Milestone: ---
Assignee: Red Hat Product Security
QA Contact:
URL:
Whiteboard: public=20100923,reported=20101006,sou...
: 649614 (view as bug list)
Depends On: 648720 648721 648722 648723 648724 648793 648794
Blocks:
TreeView+ depends on / blocked
 
Reported: 2010-11-01 21:29 UTC by Petr Matousek
Modified: 2019-06-08 18:39 UTC (History)
14 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed:


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2010:0958 normal SHIPPED_LIVE Important: kernel-rt security and bug fix update 2010-12-08 19:08:55 UTC
Red Hat Product Errata RHSA-2011:0004 normal SHIPPED_LIVE Important: kernel security, bug fix, and enhancement update 2011-01-04 16:52:05 UTC
Red Hat Product Errata RHSA-2011:0007 normal SHIPPED_LIVE Important: kernel security and bug fix update 2011-01-11 19:44:55 UTC
Red Hat Product Errata RHSA-2011:0162 normal SHIPPED_LIVE Important: kernel security and bug fix update 2011-01-18 17:45:00 UTC

Description Petr Matousek 2010-11-01 21:29:34 UTC
Description of problem:
The semctl syscall has several code paths that lead to the leakage of uninitialized kernel stack memory (namely the IPC_INFO, SEM_INFO, IPC_STAT, and SEM_STAT commands) during the use of the older, obsolete version of the semid_ds struct.  The copy_semid_to_user() function declares a semid_ds struct on the stack and copies it back to the user without initializing or zeroing the 'sem_base', 'sem_pending', 'sem_pending_last', and 'undo' pointers, allowing the leakage of 16 bytes of kernel stack memory.  The code is still reachable on 32-bit systems - when calling semctl() newer glibc's automatically OR the IPC command with the IPC_64 flag, but invoking the syscall directly allows users to use the older versions of the struct.

Reference:
http://www.openwall.com/lists/oss-security/2010/10/06/6
http://www.spinics.net/lists/mm-commits/msg80234.html

Acknowledgements:

Red Hat would like to thank Dan Rosenberg for reporting this issue.

Comment 3 Petr Matousek 2010-11-02 10:34:41 UTC
Statement:

This issue is not planned to be fixed in Red Hat Enterprise Linux 3,
due to this product being in Extended Life Cycle Phase of its
maintenance life-cycle, where only qualified security errata of critical
impact are addressed.

For further information about the Errata Support Policy, visit:
http://www.redhat.com/security/updates/errata

Comment 4 Eugene Teo (Security Response) 2010-11-04 07:29:04 UTC
Upstream commit:
http://git.kernel.org/linus/982f7c2b2e6a28f8f266e075d92e19c0dd4c6e56

Comment 5 Eugene Teo (Security Response) 2010-11-04 07:29:22 UTC
*** Bug 649614 has been marked as a duplicate of this bug. ***

Comment 6 errata-xmlrpc 2010-12-08 19:10:12 UTC
This issue has been addressed in following products:

  MRG for RHEL-5

Via RHSA-2010:0958 https://rhn.redhat.com/errata/RHSA-2010-0958.html

Comment 7 errata-xmlrpc 2011-01-04 16:53:23 UTC
This issue has been addressed in following products:

  Red Hat Enterprise Linux 5

Via RHSA-2011:0004 https://rhn.redhat.com/errata/RHSA-2011-0004.html

Comment 8 errata-xmlrpc 2011-01-11 19:46:44 UTC
This issue has been addressed in following products:

  Red Hat Enterprise Linux 6

Via RHSA-2011:0007 https://rhn.redhat.com/errata/RHSA-2011-0007.html

Comment 9 errata-xmlrpc 2011-01-18 17:45:55 UTC
This issue has been addressed in following products:

  Red Hat Enterprise Linux 4

Via RHSA-2011:0162 https://rhn.redhat.com/errata/RHSA-2011-0162.html


Note You need to log in before you can comment on or make changes to this bug.